// Balloons Game  (BALLOONS.EXE)
// OCL Sample
// balloons.hpp


#define INCL_WIN
#define INCL_PM
#define INCL_DOS


#include <ocl.hpp>
#include <OApp.hpp>
#include <OFrame.hpp>
#include <ONPipe.hpp>
#include <ONSem.hpp>
#include <OMsgs.hpp>
#include <OPMException.hpp>


#include "..\Source\Balloons.hpp"
#include "..\Source\Client.h"


// definitions

#define LRAND(a)     ((LONG)rand() % a)


// structs

typedef struct _BALLPTL
{
 POINTL  Ptl;
 LONG    deltax;
 LONG    deltay;
} BALLPTL, *PBALLPTL;



class BPipeClient : public OPipeCli
{
 public:
   BPipeClient()
     : OPipeCli(sizeof(PIPEMSG)) {}

   virtual ~BPipeClient() {}

   void OPipeCommand(PVOID pvData);
};


typedef class BalloonClient *pBalloonClient;

class BalloonClient
   : public OApp, 
     public OFrame,
     private BPipeClient
{
 private:
   OThread<BalloonClient> drawThread;

 public:
   PIPEMSG                pipeMessage;
   BALLPTL                Balls[5];
   HBITMAP                hbm;
   ULONG                  BallCount;
   ULONG                  Speed;
   ULONG                  cx;
   ULONG                  cy;
   BOOL                   goDown;

   BalloonClient()
      : OFrame(ID_MAIN, FCF_STANDARD, CS_SAVEBITS | CS_SIZEREDRAW),
        goDown(FALSE),
        drawThread(this, &BalloonClient::draw)
      {
       BallCount = 1;
       Speed = 6;
      }

   ~BalloonClient() {}
 
   void init();
   void draw();
   void calculate(PBALLPTL pBptl);
   BOOL OCommand(ULONG msg, MPARAM mp1, MPARAM mp2);
};


// end of source
