// Server.hpp (SERVER.EXE)
// common header


#define INCL_WIN
#define INCL_DOS

#include <ocl.hpp>
#include <OApp.hpp>
#include <ONPipe.hpp>
#include <ONSem.hpp>
#include <OSlider.hpp>
#include <OMsgs.hpp>
#include <OBook.hpp>
#include <OPMException.hpp>


#include "..\Source\Balloons.hpp"
#include "..\Source\Server.h"



// first page in book

typedef class CtrlPanel *pCtrlPanel;

class CtrlPanel 
   : public OCommandHandler
{
 public:
 
   CtrlPanel() {}
   ~CtrlPanel() {}

   BOOL OCommand(ULONG msg, MPARAM mp1, MPARAM mp2);
};


// second and third page in Book

typedef class NumSpeedControl *pNumSpeedControl;

class NumSpeedControl
   : public OCommandHandler
{
 private:
   BOOL     isSpeedCtrl;
   OSlider  *slider;
 
 public:

   NumSpeedControl(BOOL speeder)  // is it the speed page
     : isSpeedCtrl(speeder)
     {}

   ~NumSpeedControl() 
     {
      if (slider) delete slider;
     }

   BOOL OCommand(ULONG msg, MPARAM mp1, MPARAM mp2);
};



// pipe server

typedef class BPipeServer *pBPipeServer;

class BPipeServer : public OPipeSvr
{
 public:
   BPipeServer()
     : OPipeSvr(2*sizeof(PIPEMSG),   // inSize
                2*sizeof(PIPEMSG),   // outSize
                sizeof(PIPEMSG),     // packet size
                SVR_PIPE_OPEN_DEFAULT,
                SVR_PIPE_PIPE_DEFAULT,
                PIPE_TIMEOUT_DEFAULT,
                5)                  // max allowed clients
     {}

  virtual ~BPipeServer() {}

  void OPipeCommand(PVOID pvData) {}
};


typedef class BalloonServer *pBalloonServer;

class BalloonServer
   : public OApp, 
     public OBook,
     public BPipeServer
{
 private:
  ONSem           *svrSem;
  CtrlPanel       firstPage;
  NumSpeedControl secondPage;
  NumSpeedControl thirdPage;

 public:
  PIPEMSG         pipeMessage;


  BalloonServer()
    : OBook(ID_ICON),
      secondPage(FALSE),
      thirdPage(TRUE) {}
      
  virtual ~BalloonServer() 
    {
     if (svrSem) delete svrSem;
    }

  void init();
  BOOL OCommand(ULONG msg, MPARAM mp1, MPARAM mp2);
};


// end of source
