// OCL Sample
// Editor.cpp

#ifdef __BCPLUSPLUS__
  #define __MSC
#endif


#include "..\Source\Editor.hpp"

#ifndef __IBMCPP__
  #include <OList.c>
  #include <OThread.c>
#endif


void main(void)
{
 Editor editor;
 BOOL   succ;

 editor.winText << "A simple editor";
 if((editor.createFrame(editor.winText.text)) &&
    ((editor.textfield = new OEditor(editor))!=NULL) &&
    (editor.textfield->createMLE()))
  {
   editor.showFrame();
   editor.run();
  }

 _exit(0);
}


BOOL Editor::OCommand(ULONG msg, MPARAM mp1, MPARAM mp2)
{
 switch(msg)
  {
   case WM_SIZE:
     WinSetWindowPos(textfield->hwnd, HWND_TOP, 0, 0, 
                     SHORT1FROMMP(mp2),  SHORT2FROMMP(mp2), 
                     SWP_MOVE | SWP_SIZE);
     textfield->setFocus();
     break; 

   case WM_COMMAND:
     switch(SHORT1FROMMP(mp1))
      {
       case EDITOR_QUIT:
        WinSendMsg(hwnd, WM_CLOSE, NULL, NULL);
        break;

       case EDITOR_LOAD:
        textfield->loadFile();
        setWindowText(textfield->openedFile.text);
        break;

       case EDITOR_SAVE:
        textfield->saveFileThr.run();
        break;

       case EDITOR_SAVEAS:
        textfield->saveFileAs(); 
        setWindowText(textfield->openedFile.text);
        break; 
      }
     break;

   case WM_CLOSE:
     forceQuit();
     break; 

   default:
     return(OFrame::OCommand(msg, mp1, mp2));
  }
 return(TRUE);
#ifdef __BCPLUSPLUS__
  #pragma warn -par
#endif
}
#ifdef __BCPLUSPLUS__
  #pragma warn .par
#endif




// end of source
