// OCL Sample
// Listbox.cpp

#ifdef __BCPLUSPLUS__
  #define __MSC
#endif


#include "..\Source\Listbox.hpp"

#ifndef __IBMCPP__
  #include <OList.c>
#endif


void main(void)
{
 BoxSample sample;

 try
  {
   sample.init(); 
  }

 catch(OPMException &err)
  {
   err.viewError();
   _exit(1);
  }

 sample.run();
}


void BoxSample::run()
{
 BOOL continuable = TRUE;

 while(continuable)
  {
   continuable = FALSE;

   try {
     OApp::run(); }

   catch(LBException &except) {
     box->insertItem("Exception handled. Execution continues...");
     continuable = TRUE; }
  }
}


void BoxSample::init()
{
 winText << "ListBox Sample";
 if (!createFrame(winText.text))
   OThrowPM("Window creation failed.", 0, OException::unrecoverable);

 box = new OListBox(this, LS_NOADJUSTPOS | LS_HORZSCROLL);
 if (!box->createListBox(0, 0, 0, 0))
   OThrowPM("Listbox creation failed.", 0, OException::unrecoverable);

// listbox font and color setup
 box->setFont("10.Helv");
 box->setForeColor(RGB_BLUE);

 sizepos.cx = 400;
 sizepos.cy = 300;
 setSizePosFrame(HWND_TOP, sizepos, SWP_SIZE | SWP_SHOW | SWP_ACTIVATE);
}



BOOL BoxSample::OCommand(ULONG msg, MPARAM mp1, MPARAM mp2)
{
 switch(msg)
  {
   case WM_SIZE:
     if (box)
       WinSetWindowPos(box->hwnd, 0, 0, 0, SHORT1FROMMP(mp2), SHORT2FROMMP(mp2), SWP_SIZE | SWP_SHOW );
     break;

   case WM_COMMAND:
     switch(SHORT1FROMMP(mp1))
      {
       case BOX_QUIT:
        WinSendMsg(hwnd, WM_CLOSE, NULL, NULL);
        break;

       case BOX_EXCEPTION:
        throw LBException();
      }
     break;

   case WM_CLOSE:
     forceQuit();
     break;

   default:
     return(FALSE);
  }
 return(TRUE);
#ifdef __BCPLUSPLUS__
  #pragma warn -par
#endif
}
#ifdef __BCPLUSPLUS__
  #pragma warn .par
#endif




// end of source
