// OCL Sample OValueSet
// Value.cpp

#ifdef __BCPLUSPLUS__
  #define __MSC
#endif


#include "..\Source\Value.hpp"

#ifndef __IBMCPP__
  #include <OList.c>
#endif


void main(void)
{
 ValueSample sample;

 try
  {
   sample.init(); 
   sample.run();
  }

 catch(OPMException &err)
  {
   err.viewError();
  }
}



void ValueSample::init()
{
 COLOR color[] = { CLR_RED, CLR_GREEN, CLR_BLUE, CLR_YELLOW };

 logo.showLogo(1500);

 createDlg();
 if (!hwnd)
   OThrowPM("Dialog creation failed.", 0, OException::unrecoverable);

 if (!VSet.inherit(hwnd))
   OThrowPM("ValueSet creation failed.", 0, OException::unrecoverable);
 
 if ((!VSet.setItemAttr(1, 0, VIA_ICON)) ||
     (!VSet.setItemAttr(2, 0, VIA_BITMAP)) ||
     (!VSet.setItemAttr(3, 0, VIA_COLORINDEX)))
   OThrowPM("Setting attributes failed.", 0, OException::unrecoverable);

 if ((VSet.selected.icon = WinLoadPointer(HWND_DESKTOP, NULLHANDLE, VALUE_ICON)) == NULLHANDLE)
   OThrowPM("Loading icon failed.", 0, OException::unrecoverable);
 
 if (!VSet.setItem(1, 0, (ULONG)VSet.selected.icon))
   OThrowPM("Could not set icons.", 0, OException::unrecoverable);

 if ((VSet.selected.bitmap = GpiLoadBitmap(WinGetPS(hwnd), NULLHANDLE, VALUE_BMP, 0, 0)) == NULLHANDLE)
   OThrowPM("Loading bitmap failed.", 0, OException::unrecoverable);

 if (!VSet.setItem(2, 0, (ULONG)VSet.selected.bitmap))
   OThrowPM("Could not set bitmaps.", 0, OException::unrecoverable);

 for (ULONG count = 1; count <= 4; count++)
   if (!VSet.setItem(3, count, color[count-1]))
     OThrowPM("Could not set color.", 0, OException::unrecoverable);
 
 centerDlg();
 showDlg();
}



BOOL ValueSample::OCommand(ULONG msg, MPARAM mp1, MPARAM mp2)
{
 switch(msg)
  {
   case WM_CONTROL:
    switch(SHORT2FROMMP(mp1)) {
     case VN_SELECT:
     case VN_ENTER: {
       OString Notification;
       CHAR    pszTmp[5];

       VSet.querySelected();
       if ((SHORT2FROMMP(mp1)) == VN_SELECT)
         Notification << "VN_SELECT for item at row ";
       else
         Notification << "VN_ENTER for item at row ";
       _itoa(VSet.selected.row, pszTmp, 10);
       Notification + pszTmp;
       Notification + " Column ";
       _itoa(VSet.selected.col, pszTmp, 10);
       Notification + pszTmp;
       WinSetDlgItemText(hwnd, VALUE_STATUS, Notification.text);
       break; }}
     break;

   case WM_COMMAND:
     WinSendMsg(hwnd, WM_CLOSE, NULL, NULL);
     break;

   case WM_CLOSE:
     hideDlg();
     forceQuit();
     break;

   default:
     return(FALSE);
  }
 return(TRUE);
#ifdef __BCPLUSPLUS__
  #pragma warn -par
#endif
}
#ifdef __BCPLUSPLUS__
  #pragma warn .par
#endif




// end of source
